/* AppExceptions
 *
 * A category of Application that provides methods for mapping
 * ASCII names to integers for use in NeXTSTEP exception handling.
 *
 * Copyright 1991, 1992 Scott Hess.  This source code may be
 * redistributed and modified without restriction.  Well, one
 * restriction - do not claim that you wrote it.
 *
 * Scott Hess
 * 12901 Upton Avenue South, #326
 * Burnsville, MN  55337
 * (612) 895-1208
 * scott@gac.edu
 * shess@ssesco.com
 */
#import <appkit/Application.h>

@interface Application (AppExceptions)
/* I store this category in an ar(1) library of code shared between
 * a number of applications.  Unfortunately, categories generate no
 * symbols that allow them to be pulled from the library on link.  I
 * put "appExceptionsReference=0;" somewhere else in the app just to
 * reference the object module and make certain it's in the app.  Most
 * people can simply ignore this ...
 */
extern int appExceptionsReference;

/* Return a unique integer for the named exception, between
 * NX_APPBASE and NX_APPBASE+999.
 */
-(int)exceptionFor:(const char *)name;
/* Return the name for exception.  Return NULL if no mapping.
 */
-(const char *)nameForException:(int)exception;

/* Raise the named exception. */
- raiseException:(const char *)name with:(const void *)data1 with:(const void *)data2;
- raiseException:(const char *)name with:(const void *)data1;
- raiseException:(const char *)name;
@end

